/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package managed_beans;

import entities.Reservation;
import java.time.Duration;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.inject.Named;
import javax.enterprise.context.RequestScoped;
import javax.faces.annotation.FacesConfig;
import util.dao.ReservationDAO;

/**
 *
 * @author jelic
 */
@Named(value = "labManagedBean")
@RequestScoped
@FacesConfig(version = FacesConfig.Version.JSF_2_3)
public class LabManagedBean {

    /**
     * Creates a new instance of LabManagedBean
     */
    public LabManagedBean() {
    }
    
    private List<Reservation> all = new ArrayList<>();
    private String message;

    @PostConstruct
    public void fetchAllReservations() {
        ReservationDAO reservationDAO = new ReservationDAO();
        all = reservationDAO.getAllReservations();
    }

    public List<Reservation> getAll() {
        return all;
    }

    public void setAll(List<Reservation> all) {
        this.all = all;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public boolean longReservationDuration(Reservation r){
        Duration d = Duration.between(r.getFrom(), r.getTo());
        return d.toHours()>=2;
    }

    public String deleteReservation(Reservation r) {
        if (!(new ReservationDAO().deleteReservation(r))) {
            message = "Doslo je do greske pri brisanju.";
        } else {
            message = "";           
        }
        return "lab.xhtml?faces-redirect=true";
    }
    
}
