/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package managed_beans;

import entities.Reservation;
import java.util.Date;
import java.util.List;
import javax.inject.Named;
import javax.enterprise.context.RequestScoped;
import javax.faces.annotation.FacesConfig;
import util.DateConverter;
import util.dao.ReservationDAO;

/**
 *
 * @author jelic
 */
@Named(value = "teacherManagedBean")
@RequestScoped
@FacesConfig(version = FacesConfig.Version.JSF_2_3)
public class TeacherManagedBean {

    /**
     * Creates a new instance of TeacherManagedBean
     */
    public TeacherManagedBean() {
    }
    
    private String title;
    private Date from;
    private Date to;
    private List<String> labs;

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Date getFrom() {
        return from;
    }

    public void setFrom(Date from) {
        this.from = from;
    }

    public Date getTo() {
        return to;
    }

    public void setTo(Date to) {
        this.to = to;
    }

    public List<String> getLabs() {
        return labs;
    }

    public void setLabs(List<String> labs) {
        this.labs = labs;
    }
    
    public void insertReservation(){
        Reservation r = new Reservation();
        r.setFrom(DateConverter.utilToLocalDateTime(from));
        r.setLabs(labs);
        r.setTitle(title);
        r.setTo(DateConverter.utilToLocalDateTime(to));

        ReservationDAO reservationDAO = new ReservationDAO();

        // rucna provera
        /*for (Reservation res : reservationDAO.getAllReservations()) {
            if (((r.getFrom().isAfter(res.getFrom()) || r.getFrom().isEqual(res.getFrom())) 
                    && (r.getFrom().isBefore(res.getTo()) || r.getFrom().isEqual(res.getTo()))) 
                    || ((r.getTo().isAfter(res.getFrom()) || r.getTo().isEqual(res.getFrom())) 
                    && (r.getTo().isBefore(res.getTo()) || r.getTo().isEqual(res.getTo())))) {
                for (String labReserved : res.getLabs()) {
                    for (String labWant : r.getLabs()) {
                        if (labReserved.equals(labWant)) {
                            message = "Zauzeto ";
                            return;
                        }
                    }
                }
            }
        }*/

        // sa datumima u sql upitu
        for (Reservation res : reservationDAO.getAllReservationsBetween(r.getFrom(), r.getTo())) {
            for (String labReserved : res.getLabs()) {
                for (String labWant : r.getLabs()) {
                    if (labReserved.equals(labWant)) {
                        message = "Zauzeto";
                        return;
                    }
                }
            }
        }

        // ako je sve OK proslo, ubaci u bazu
        if (reservationDAO.insertReservation(r)) {
            message = "Uspeh!";
            title = "";
            from = null;
            to = null;
            labs = null;
        } else {
            message = "Doslo je do greske prilikom unosa.";
        }
    }
    
    private String message;

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }
    
    
}
